#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")

STATIC lVISTA := .F.

PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIService
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"ArpAlwaysSourceRoute",;
"ArpUseEtherSNAP",;
"Caption",;
"DatabasePath",;
"DeadGWDetectEnabled",;
"DefaultIPGateway",;
"DefaultTOS",;
"DefaultTTL",;
"Description",;
"DHCPEnabled",;
"DHCPLeaseExpires",;
"DHCPLeaseObtained",;
"DHCPServer",;
"DNSDomain",;
"DNSDomainSuffixSearchOrder",;
"DNSEnabledForWINSResolution",;
"DNSHostName",;
"DNSServerSearchOrder",;
"DomainDNSRegistrationEnabled",;
"ForwardBufferMemory",;
"FullDNSRegistrationEnabled",;
"GatewayCostMetric",;
"IGMPLevel",;
"Index",;
"IPAddress",;
"IPConnectionMetric",;
"IPEnabled",;
"IPFilterSecurityEnabled",;
"IPPortSecurityEnabled",;
"IPSecPermitIPProtocols",;
"IPSecPermitTCPPorts",;
"IPSecPermitUDPPorts",;
"IPSubnet",;
"IPUseZeroBroadcast",;
"IPXAddress",;
"IPXEnabled",;
"IPXFrameType",;
"IPXMediaType",;
"IPXNetworkNumber",;
"IPXVirtualNetNumber",;
"KeepAliveInterval",;
"KeepAliveTime",;
"MACAddress",;
"MTU",;
"NumForwardPackets",;
"PMTUBHDetectEnabled",;
"PMTUDiscoveryEnabled",;
"ServiceName",;
"SettingID",;
"TcpipNetbiosOptions",;
"TcpMaxConnectRetransmissions",;
"TcpMaxDataRetransmissions",;
"TcpNumConnections",;
"TcpUseRFC1122UrgentPointer",;
"TcpWindowSize",;
"WINSEnableLMHostsLookup",;
"WINSHostLookupFile",;
"WINSPrimaryServer",;
"WINSScopeID" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_NetworkAdapterConfiguration.TXT
   SET ALTER ON

   IF "VISTA" $ OS(OS_PRODUCT) .OR. "WIN2003" $ OS(OS_PRODUCT) .OR. "WIN2008" $ OS(OS_PRODUCT)
      lVISTA := .T.
   ENDIF
   IF lVISTA
      IF strComputer == "Localhost"
         objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIService  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIService  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIService:ExecQuery("select * from Win32_NetworkAdapterConfiguration",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("ArpAlwaysSourceRoute"),;
     oService:getProperty("ArpUseEtherSNAP"),;
     oService:getProperty("Caption"),;
     oService:getProperty("DatabasePath"),;
     oService:getProperty("DeadGWDetectEnabled"),;
     oService:getProperty("DefaultIPGateway"),;
     oService:getProperty("DefaultTOS"),;
     oService:getProperty("DefaultTTL"),;
     oService:getProperty("Description"),;
     oService:getProperty("DHCPEnabled"),;
     oService:getProperty("DHCPLeaseExpires"),;
     oService:getProperty("DHCPLeaseObtained"),;
     oService:getProperty("DHCPServer"),;
     oService:getProperty("DNSDomain"),;
     oService:getProperty("DNSDomainSuffixSearchOrder"),;
     oService:getProperty("DNSEnabledForWINSResolution"),;
     oService:getProperty("DNSHostName"),;
     oService:getProperty("DNSServerSearchOrder"),;
     oService:getProperty("DomainDNSRegistrationEnabled"),;
     oService:getProperty("ForwardBufferMemory"),;
     oService:getProperty("FullDNSRegistrationEnabled"),;
     oService:getProperty("GatewayCostMetric"),;
     oService:getProperty("IGMPLevel"),;
     oService:getProperty("Index"),;
     oService:getProperty("IPAddress"),;
     oService:getProperty("IPConnectionMetric"),;
     oService:getProperty("IPEnabled"),;
     oService:getProperty("IPFilterSecurityEnabled"),;
     oService:getProperty("IPPortSecurityEnabled"),;
     oService:getProperty("IPSecPermitIPProtocols"),;
     oService:getProperty("IPSecPermitTCPPorts"),;
     oService:getProperty("IPSecPermitUDPPorts"),;
     oService:getProperty("IPSubnet"),;
     oService:getProperty("IPUseZeroBroadcast"),;
     oService:getProperty("IPXAddress"),;
     oService:getProperty("IPXEnabled"),;
     oService:getProperty("IPXFrameType"),;
     oService:getProperty("IPXMediaType"),;
     oService:getProperty("IPXNetworkNumber"),;
     oService:getProperty("IPXVirtualNetNumber"),;
     oService:getProperty("KeepAliveInterval"),;
     oService:getProperty("KeepAliveTime"),;
     oService:getProperty("MACAddress"),;
     oService:getProperty("MTU"),;
     oService:getProperty("NumForwardPackets"),;
     oService:getProperty("PMTUBHDetectEnabled"),;
     oService:getProperty("PMTUDiscoveryEnabled"),;
     oService:getProperty("ServiceName"),;
     oService:getProperty("SettingID"),;
     oService:getProperty("TcpipNetbiosOptions"),;
     oService:getProperty("TcpMaxConnectRetransmissions"),;
     oService:getProperty("TcpMaxDataRetransmissions"),;
     oService:getProperty("TcpNumConnections"),;
     oService:getProperty("TcpUseRFC1122UrgentPointer"),;
     oService:getProperty("TcpWindowSize"),;
     oService:getProperty("WINSEnableLMHostsLookup"),;
     oService:getProperty("WINSHostLookupFile"),;
     oService:getProperty("WINSPrimaryServer"),;
     oService:getProperty("WINSScopeID") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? jMax := LEN(aItem)
      ? iMax := LEN(aItem[1])
?"*****************************************************************************"
      FOR j := 1 TO jMax
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT

?"*****************************************************************************"

      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_NetworkAdapterConfiguration.TXT","Notepad.exe",.T.)

RETURN
